/*	DANUTIL.H		06/24/1988		Dan Brown	    */
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*   Copyright 1999, Caldera Thin Client Systems, Inc.                      */
/*   This software is licensed under the GNU Public License.                */
/*   See LICENSE.TXT for further information.                               */
/*                                                                          */
/*   Historical Copyright                                                   */
/*                                                                          */
/*    	Copyright (c) 1988 Digital Research Inc.			    */
/*    The software contained in this listing is proprietary to		    */
/*    Digital Research Inc., Monterey, California and is		    */
/*    covered by U.S. and other copyright protection.  Unaurthorized	    */
/*    copying, adaptation, distribution, use or display is prohibited	    */
/*    and may be subject to civil and criminal penalties.  Disclosure	    */
/*    to others is prohiited.  For the terms and conditions of soft-	    */
/*    ware code use refer to the appropriate Digital Research		    */
/*    license agreement.						    */
/*--------------------------------------------------------------------------*/
/*
Date	Who	Spr	Comments
----	---	---	--------
910502	RSF		Remove unused 'handle' from vst_lattr().
910419	RSF		prototype for c_strcpy
910405	RSF		Change LONG to SLONG
*/

/*--------------------------------------------------------------------------*/
/* Defines for format word of formatted atoi or itoa calls.		    */
/*--------------------------------------------------------------------------*/

#define FMT_SIGN    0x1000		/* Mask for sign bit in format.	    */
#define FMT_DPLACES 0x0F00		/* Mask for number of decimal places*/
					/*  in format.			    */
#define FMT_LENGTH  0x00FF		/* Mask for max length.		    */

EXTERN	SCRN	screen;			/* Misc. screen info.		    */
EXTERN	BYTE	decimal;		/* Decimal charater.		    */
EXTERN	WORD	clr_pat[];		/* Mapping of colors to	    */

    EXTERN FBYTE
*lstrncpy(     FBYTE	*d,
	       FBYTE	*s,
	       WORD     n
	       );

    EXTERN SLONG
labs(     SLONG	val
	  );

    EXTERN SLONG
lmid(    SLONG	lo, 
	 SLONG	val,
	 SLONG	hi
	 );

    EXTERN WORD
mid(    WORD	lo, 
	WORD	val,
	WORD	hi
	);
	
    EXTERN SLONG
lround(     SLONG	i,
	    SLONG	step
	    );

    EXTERN WORD
mask_value(     WORD	fmt,
		WORD	mask
		);

    EXTERN WORD
path_exists( 
	     BYTE    *path		/* Directory to check for.	    */
	   );

    EXTERN VOID
reverse( 
	 BYTE	    *s			/* String to reverse.		    */
	 );

    EXTERN VOID
litoa(     SLONG	i,
	   BYTE	s[]
	   );

    EXTERN SLONG
latoi(     BYTE	s[]
	   );

    EXTERN WORD
decode_format(     BYTE	*str
		   );

    EXTERN SLONG
fmt_latoi(     BYTE    *str,
	       WORD    fmt
	       );

    EXTERN VOID
fmt_litoa(     SLONG	val,
	       WORD	fmt,
	       FBYTE    *str
	       );
    EXTERN VOID
vst_fattr(
    WORD	handle,
    WORD	wmode,
    WORD	fintr,
    WORD	fstyle,
    WORD	fclr,
    WORD	fpmtr );

    EXTERN VOID
vst_lattr( 
	   WORD	    wmode,		/* Writing mode.		    */
	   WORD	    ltype,		/* Line type.			    */
	   WORD	    lclr,		/* Line color.			    */
	   WORD	    lbeg,		/* Beginning end style.		    */
	   WORD	    lend,		/* Ending end style.		    */
	   WORD	    lwidth		/* Line width.			    */
	   );

    EXTERN VOID
init_evmulti(     EVMULT  *evm
		  );

    EXTERN VOID
set_rscstr( FDOBJECT	*tree,
	    WORD	obj,
	    FBYTE	*str
	    );

    EXTERN FBYTE
*get_rscstr(     FDOBJECT	*tree,
		 WORD	obj
		 );

    EXTERN WORD
find_parent(     FDOBJECT	*tree,
		 WORD	obj
		 );

    EXTERN VOID
get_obloc(     TREE	tree,
	       WORD	ob,
	       RECT	*r
	       );


    EXTERN VOID
upd_ob_state( TREE	tree,		/* Tree address of the object to    */
					/* update.			    */
	      WORD	obj,		/* Object number of object.	    */
	      WORD	new_state,	/* New state to be ORed with old.   */
	      BOOLEAN	toggle,		/* If true new state XORed.	    */
	      BOOLEAN	redraw		/* If true object redrawn.	    */
	      );

    EXTERN VOID
dsel_rbut( TREE	    tree,		/* Tree address of button.	    */
	   WORD	    obj,		/* Object number of known button.   */
	   WORD	    redraw		/* Redraw flag.			    */
	   );

    EXTERN VOID
evnt_loop(
    EVMULT	*evm,
    WORD	exit_ev,
    TREE	tree,
    WORD	obj,
    WORD	(*func)(),
    FBYTE	*func_data );

