/****************************************************************************
*   Copyright 1999, Caldera Thin Client Systems, Inc.                       *
*   This software is licensed under the GNU Public License.                 *
*   See LICENSE.TXT for further information.                                *
*                                                                           *
*   Historical Copyright                                                    *
*                                                                           *
*   Copyright (c) 1991  Digital Research Inc.  All rights reserved.    *
*   The Software Code contained in this listing is proprietary to Digital   *
*   Research Inc., Monterey, California, and is covered by U.S. and other   *
*   copyright protection.  Unauthorized copying, adaption, distribution,    *
*   use or display is prohibited and may be subject to civil and criminal   *
*   penalties.  Disclosure to others is prohibited.  For the terms and      *
*   conditions of software code use, refer to the appropriate Digital       *
*   Research License Agreement.						    *
*****************************************************************************
*		      U.S. GOVERNMENT RESTRICTED RIGHTS			    *
*                    ---------------------------------                      *
*  This software product is provided with RESTRICTED RIGHTS.  Use, 	    *
*  duplication or disclosure by the Government is subject to restrictions   *
*  as set forth in FAR 52.227-19 (c) (2) (June, 1987) when applicable or    *
*  the applicable provisions of the DOD FAR supplement 252.227-7013 	    *
*  subdivision (b)(3)(ii) (May 1981) or subdivision (c)(1)(ii) (May 1987).  *
*  Contractor/manufacturer is Digital Research Inc. / 70 Garden Court /     *
*  BOX DRI / Monterey, CA 93940.					    *
*****************************************************************************
* $Header: m:/davinci/users//groups/panther/dsk/rcs/inidefs.h 3.1 91/08/19 16:32:21 system Exp $
* $Log:	inidefs.h $
 * Revision 3.1  91/08/19  16:32:21  system
 * ViewMAX 2 sources
 * 
 * Revision 3.5  91/07/26  13:24:16  sbc
 * add extern for shel_find_ini()
 * 
 * Revision 3.4  91/06/10  16:26:06  sbc
 * changes for new INI file format. Be sure to get new version of
 * VIEWMAX.INI on net in \drdesk.
 * 
 * Revision 3.3  91/06/04  13:02:04  sbc
 * misc housekeeping and other ravings...
 * 
 * Revision 3.2  91/05/31  11:20:27  sbc
 * misc changes associated with rewrites in deskapp.c and inifiles.c
 * 
 * Revision 3.1  91/05/16  14:47:59  fontes
 * Separate branch for Beta bug fixes, separate from split-mode windows
 * 
 * Revision 2.3  91/05/08  13:17:20  fontes
 * New routines
 * 
 * Revision 2.2  91/04/29  13:16:10  whf
 * changed i/f to use FBYTE *
 * 
 * Revision 2.1  91/04/26  16:21:47  fontes
 * Create module
 * 
* 
 Date	Who	Spr	Comments
 ----	---	---	--------
910507	RSF		Prototypes for new routines.
910429	WHF		Changed i/f to FAR data ptrs (FBYTE *)
910425	RSF		Move defs pertinent to ini file routines here.
*****************************************************************************/

/****************************************************************************
* File:		inidefs.h
*
* Description:	
*
* Build Info:	ndmake -f vm2.mak
*
* Overview:	
*  
*****************************************************************************/

#include <stdio.h>

#define	INI_OPENERR	-1
#define INI_SECTIONERR	-2
#define	INI_ITEMERR	-3
#define	INI_INVALIDERR	-4
#define	INI_MEMERR	-5
#define	INI_SUCCESS	0

#define	INI_PATHNAME_LEN	128
#define	INI_SECTION_LEN		40		/* also the item len */
#define	INI_TEMPNAME_LEN	256
#define	INI_STRING_LEN		256
#define MAX_LINE_LEN		128

extern void	CopyFile( WORD dstHndl, WORD srcHndl ) ;
extern void	note_start_path( void ) ;
extern long	find_offset( int fHandle, char * str ) ;

extern BOOLEAN	shel_find_ini( char far * fname ) ;
extern WORD 	ini_open_file( FBYTE *fname, BOOLEAN is_write_ini ) ;
extern long	ini_section_offset( WORD fHndl, char * section ) ;
extern long	ini_item_offset( WORD fHndl, long offset, char * item ) ;
extern WORD	ini_write_section( WORD fHndl, char * section ) ;
extern WORD	ini_write_item( WORD fHndl, char * item, char * string ) ;
extern WORD	ini_write( WORD fname_num, FBYTE *section, FBYTE *item,
				FBYTE *string ) ;
extern WORD	ini_read( WORD fname_num, FBYTE *section, FBYTE *item,
			       FBYTE *buffer, WORD size ) ;

/* end of inidefs.h */
